
'Header to support the embedding of ScriptBasic into an application
'Derived from ScriptBasic 2.1 source code (Original Author Peter Verhas)

'Scriba.inc
'Charles Pegge
'16 September 2009


'For FreeBasic

'/*
'scriba.h
'*/

#Inclib "libscriba"

'/*
'#ifndef __SCRIBA_H__
'#define __SCRIBA_H__ 1
'#ifdef  __cplusplus
'  extern "C" {
'#endif
'#include "report.h"
'#include "lexer.h"
'#include "sym.h"
'#include "expression.h"
'#include "syntax.h"
'#include "reader.h"
'#include "myalloc.h"
'#include "builder.h"
'#include "memory.h"
'#include "execute.h"
'#include "buildnum.h"
'#include "conftree.h"
'#include "filesys.h"
'#include "errcodes.h"
'#ifdef _DEBUG
'#include "testalloc.h"
'#endif
'#include "command.h"
'#include "epreproc.h"
'#include "ipreproc.h"
'#include "uniqfnam.h"
'#include "modumana.h"
'#include "ipreproc.h"
'*/


'/*
'typedef struct _SbProgram {
'  void *pMEM;
'  void * (*maf)(size_t);
'  void   (*mrf)(void *);
'  unsigned long fErrorFlags;
'  char *pszFileName;
'  char *pszCacheFileName;
'  char *FirstUNIXline;
'
'  void *fpStdouFunction;
'  void *fpStdinFunction;
'  void *fpEnvirFunction;
'  void *pEmbedder;
'  void *fpReportFunction;
'  void *pReportPointer;
'  pSupportTable pSTI;
'  ExecuteObject *pEPo;
'
'  tConfigTree   *pCONF;
'  ReadObject    *pREAD;
'  LexObject     *pLEX;
'  eXobject      *pEX;
'  BuildObject   *pBUILD;
'  ExecuteObject *pEXE;
'  PreprocObject *pPREP;
'  } SbProgram, *pSbProgram;
'*/


type SbProgram
  pMEM              as ulong
  maf               as ulong
  mrf               as ulong
  fErrorFlags       as ulong
  pszFileName       as ulong
  pszCacheFileName  as ulong
  FirstUNIXline     as ulong

  fpStdouFunction   as ulong
  fpStdinFunction   as ulong
  fpEnvirFunction   as ulong
  pEmbedder         as ulong
  fpReportFunction  as ulong
  pReportPointer    as ulong
  pSTI              as ulong
  pEPo              as ulong

  pCONF             as ulong
  pREAD             as ulong
  pLEX              as ulong
  pEX               as ulong
  pBUILD            as ulong
  pEXE              as ulong
  pPREP             as ulong
end type

'  } SbProgram, *pSbProgram;



'/*
'typedef struct _SbData {
'  unsigned char type;
'  unsigned long size;
'  union {
'    double d;
'    long   l;
'    unsigned char *s;
'    } v;
'  } SbData, *pSbData;
'*/



type SbData
  typ as byte
  siz as ulong
  union
    dbl as double
    lng as long
    str as zstring ptr
  end union
end type


#define SBT_UNDEF  0
#define SBT_DOUBLE 1
#define SBT_LONG   2
#define SBT_STRING 3
#define SBT_ZCHAR  4

#define scriba_GetType(Y,X)   ( (X).type )
#define scriba_GetLength(Y,X) ( (X).size )
#define scriba_GetString(Y,X) ( (X).v.s  )
#define scriba_GetLong(Y,X) ( (X).v.l  )
#define scriba_GetDouble(Y,X) ( (X).v.d  )


'/*
'#ifdef WIN32
'#define CONFIG_ENVIR "Softwarebyval ScriptBasicbyval config"
'#define CONFIG_FILE  "SCRIBA.INI"
'#else
'#define CONFIG_ENVIR "SCRIBACONF"
'#define CONFIG_FILE  "/etc/scriba/basic.conf"
'#endif
'
'#if (defined(_WIN32) || defined(__MACOS__) || defined(WIN32))
'# ifdef __cplusplus
'#  define SCRIBA_MAIN_LIBSPEC extern "C" __declspec(dllexport) 
'# else
'#  define SCRIBA_MAIN_LIBSPEC __declspec(dllexport) 
'# endif
'#else
'# ifdef __cplusplus
'#  define SCRIBA_MAIN_LIBSPEC extern "C" 
'# else
'#  define SCRIBA_MAIN_LIBSPEC
'# endif
'#endif
'*/


'NEW
'
'To create a new T<SbProgram> object you have to call this function. The two arguments
'should point to T<malloc> and T<free> or similar functions. All later memory allocation
'and releasing will be performed using these functions.
'
'Note that this is the only function that does not require a pointer to an T<SbProgram> object.

'SCRIBA_MAIN_LIBSPEC pSbProgram scriba_new(void * (*maf)(size_t),  void   (*mrf)(void *));
declare function scriba_new lib "libscriba.dll" alias "scriba_new" (byval maf as ulong, byval mrf as ulong) as ulong




'DESTROY

'After a ScriptBasic program was successfully execued and there is no need to
'run it anymore call this function to release all memory associated with the
'code.

'void scriba_destroy(byval pSbProgram as ulong);

declare sub scriba_destroy lib "libscriba.dll" alias "scriba_destroy" (byval pSbProgram as ulong)






'NEW SBDATA

'Allocate and return a pointer to the allocated T<SbData> structure.
'
'This structure can be used to store ScriptBasic variable data,
'long, double or string. This function is called by other functions
'from this module. Usually the programmer, who embeds ScriptBasic will rarely
'call this function directly. Rather he/she will use R<scriba_NewSbLong()> (as an example)
'that creates a variable capable holding a T<long>, sets the type to 
'be T<SBT_LNG> and stores initial value.
'
'See also R<scriba_NewSbLong()>, R<scriba_NewSbDouble()>, R<scriba_NewSbUndef()>, R<scriba_NewSbString()>,
'R<scriba_NewSbBytes()>, R<scriba_DestroySbData()>.

'pSbData scriba_NewSbData(pSbProgram pProgram);
declare function scriba_NewSbData lib "libscriba.dll" alias "scriba_NewSbData" (byval pSbProgram as ulong) as ulong






'INIT SBDATA

'This function initializes an SbData structure to hold undef value.
'This function should be used to initialize an allocated T<SbData>
'memory structure. This function internally is called by R<scriba_NewSbData()>.
'
'See also R<scriba_NewSbLong()>, R<scriba_NewSbDouble()>, R<scriba_NewSbUndef()>, R<scriba_NewSbString()>,
'R<scriba_NewSbBytes()>, R<scriba_DestroySbData()>.

'void scriba_InitSbData(pProgram, pSbData p);
declare sub scriba_InitSbData lib "libscriba.dll" alias "scriba_InitSbData" (byval pSbProgram as ulong, d as SbData)





'UNDEF DATA


'This function sets an T<SbData> structure to hold the undefined value.

'This function should should not be used instead of R<scriba_InitSbData()>.
'While that function should be used to inititalize the memory structure this
'function should be used to set the value of an alreasdy initialized and probably
'used T<SbData> variable to T<undef>.
'
'The difference inside is that if the T<SbData> structure is a string then this
'function releases the memory occupied by the string, while R<scriba_InitSbData()> does not.
'
'See also R<scriba_NewSbLong()>, R<scriba_NewSbDouble()>, R<scriba_NewSbUndef()>, R<scriba_NewSbString()>,
'R<scriba_NewSbBytes()>, R<scriba_DestroySbData()>.

'void scriba_UndefSbData(pSbProgram pProgram, pSbData p);
declare sub scriba_UndefSbData lib "libscriba.dll" alias "scriba_UndefSbData" (byval pSbProgram as ulong, p as SbData)

'//1








'NEW SBLONG

'This function allocates and returns a pointer pointing to a structure of
'type T<SbData> holding a T<long> value. If the allocation failed the return
'value is T<NULL>. If the memory allocation was successful the allocated
'structure will have the type T<SBT_LONG> and will hold the initial value
'specified by the argument T<lInitValue>.

'See also R<scriba_NewSbLong()>, R<scriba_NewSbDouble()>, R<scriba_NewSbUndef()>, R<scriba_NewSbString()>,
'R<scriba_NewSbBytes()>, R<scriba_DestroySbData()>.

'pSbData scriba_NewSbLong(pSbProgram pProgram,long dInitValue);
declare sub scriba_NewSbLong lib "libscriba.dll" alias "scriba_NewSbLong" (byval pSbProgram as ulong, byval dInitValue as long)




'NEW SBDOUBLE

'This function allocates and returns a pointer pointing to a structure of
'type T<SbData> holding a T<double> value. If the allocation failed the return
'value is T<NULL>. If the memory allocation was successful the allocated
'structure will have the type T<SBT_DOUBLE> and will hold the initial value
'specified by the argument T<dInitValue>.

'See also R<scriba_NewSbLong()>, R<scriba_NewSbDouble()>, R<scriba_NewSbUndef()>, R<scriba_NewSbString()>,
'R<scriba_NewSbBytes()>, R<scriba_DestroySbData()>.

'pSbData scriba_NewSbDouble(pSbProgram pProgram,double dInitValue);
declare function scriba_NewSbDouble lib "libscriba.dll" alias "scriba_NewSbDouble" (byval pSbProgram as ulong,byval dInitValue as double) as ulong





'NEW SBUNDEF

'This function allocates and returns a pointer pointing to a structure of
'type T<SbData> holding an T<undef> value. If the allocation failed the return
'value is T<NULL>. If the memory allocation was successful the allocated
'structure will have the type T<SBT_UNDEF>.

'See also R<scriba_NewSbLong()>, R<scriba_NewSbDouble()>, R<scriba_NewSbUndef()>, R<scriba_NewSbString()>,
'R<scriba_NewSbBytes()>, R<scriba_DestroySbData()>.

'pSbData scriba_NewSbUndef(pSbProgram pProgram);
declare function scriba_NewSbUndef lib "libscriba.dll" alias "scriba_NewSbUndef" (byval pSbProgram as ulong) as ulong




'NEW SBSTRING
'
'This function allocates and returns a pointer pointing to a structure of
'type T<SbData> holding a string value. If the allocation failed the return
'value is T<NULL>. If the memory allocation was successful the allocated
'structure will have the type T<SBT_STRING> and will hold the initial value
'specified by the argument T<pszInitValue>.

'B<Note on ZCHAR termination:>

'The init value T<pszInitValue> should be a zchar terminated string. Note that
'ScriptBasic internally stores the strings as series byte and the length of the
'string without any terminating zchar. Therefore the length of the string
'that is stored should have been T<strlen(pszInitValue)>. This does not contain the
'terminating zchar.

'In reality however we allocate an extra byte that stores the zchar, but the
'size of the string is one character less. Therefore ScriptBasic routines
'will recognize the size of the string correct and also the caller can
'use the string using the macro T<scriba_GetString> as a zchar terminated
'C string. This requires an extra byte of storage for each string passed from the
'embedding C application to ScriptBasic, but saves a lot of hedeache and also
'memory copy when the string has to be used as a zchar terminated string.

'See also R<scriba_NewSbLong()>, R<scriba_NewSbDouble()>, R<scriba_NewSbUndef()>, R<scriba_NewSbString()>,
'R<scriba_NewSbBytes()>, R<scriba_DestroySbData()>.

'pSbData scriba_NewSbString(pSbProgram pProgram, char *pszInitValue);
declare function scriba_NewSbString lib "libscriba.dll" alias "scriba_NewSbString" (byval pSbProgram as ulong, byval pszInitValue as zstring ptr) as ulong






'NEW SBBYTES

'This function allocates and returns a pointer pointing to a structure of
'type T<SbData> holding a string value. If the allocation failed the return
'value is T<NULL>. If the memory allocation was successful the allocated
'structure will have the type T<SBT_STRING> and will hold the initial value
'specified by the argument T<pszInitValue> of the length T<len>.

'This function allocates T<len>+1 number of bytes data and
'stores the initial value pointed by T<pszInitValue> in it.

'The extra plus one byte is an extra terminating zero char
'that may help the C programmers to handle the string
'in case it is not binary. Please also read the not on the terminating ZChar
'in the function R<scriba_NewSbString()>.
'
'See also R<scriba_NewSbLong()>, R<scriba_NewSbDouble()>, R<scriba_NewSbUndef()>, R<scriba_NewSbString()>,
'R<scriba_NewSbBytes()>, R<scriba_DestroySbData()>.

'pSbData scriba_NewSbBytes(pSbProgram pProgram,  unsigned long len, unsigned char *pszInitValue);
declare function scriba_NewSbBytes lib "libscriba.dll" alias "scriba_NewSbBytes" (byval pSbProgram as ulong,  byval len as long, byval pszInitValue as zstring ptr) as ulong




'DESTROY SBDATA

'Call this function to release the memory that was allocated by any
'of the T<NewSbXXX> functions. This function releases the memory and
'also cares to release the memory occupied by the characters in case the
'value had the type T<SBT_STRING>.
'
'See also R<scriba_NewSbLong()>, R<scriba_NewSbDouble()>, R<scriba_NewSbUndef()>, R<scriba_NewSbString()>,
'R<scriba_NewSbBytes()>, R<scriba_DestroySbData()>.

'void scriba_DestroySbData(pSbProgram pProgram, pSbData p);
declare sub scriba_DestroySbData lib "libscriba.dll" alias "scriba_DestroySbData" (byval pSbProgram as ulong, d as SbData)






'PURGE READER MEMORY

'Call this function to release all memory that was allocated by the
'reader module. The memory data is needed so long as long the lexical analyzer
'has finished.

'void scriba_PurgeReaderMemory(pSbProgram pProgram);
declare sub scriba_PurgeReaderMemory lib "libscriba.dll" alias "scriba_PurgeReaderMemory" (byval pSbProgram as ulong)






'PURGE LEXER MEMORY

'void scriba_PurgeLexerMemory(pSbProgram pSBProgram);
declare sub scriba_PurgeLexerMemory lib "libscriba.dll" alias "scriba_PurgeLexerMemory" (byval pSbProgram as ulong)





'PURGE SYNTAX MEMORY

'void scriba_PurgeSyntaxerMemory(pSbProgram pProgram);
declare sub scriba_PurgeSyntaxerMemory lib "libscriba.dll" alias "scriba_PurgeSyntaxerMemory" (byval pSbProgram as ulong)






'PURGE BUILDER MEMORY

'void scriba_PurgeBuilderMemory(pSbProgram pProgram);
declare sub scriba_PurgeBuilderMemory  lib "libscriba.dll" alias "scriba_PurgeBuilderMemory" (byval pSbProgram as ulong)






'PURGE PREPROCESSOR MEMORY

'This function purges the memory that was needed to run the preprocessors.

'void scriba_PurgePreprocessorMemory(pSbProgram pProgram);
declare sub scriba_PurgePreprocessorMemory lib "libscriba.dll" alias "scriba_PurgePreprocessorMemory" (byval pSbProgram as ulong)





'PURGE EXECUTE MEMORY

'This function purges the memory that was needed to execute the program,
'but before that it executes the finalization part of the execution.

'void scriba_PurgeExecuteMemory(pSbProgram pProgram);
declare sub scriba_PurgeExecuteMemory lib "libscriba.dll" alias "scriba_PurgeExecuteMemory" (byval pSbProgram as ulong)





'SET FILENAME

'Call this function to set the file name where the source information is.
'This file name is used by the functions R<scriba_LoadBinaryProgram()> and
'R<scriba_LoadSourceProgram> as well as error reporting functions to display
'the location of the error.

'int scriba_SetFileName(pSbProgram pProgram, char *pszFileName);
declare function scriba_SetFileName lib "libscriba.dll" alias "scriba_SetFileName" (byval pSbProgram as ulong, byval pszFileName as zstring ptr) as long





'LOAD CONFIGURATION

'R<scriba_LoadConfiguration()> and R<scriba_InheritConfiguration()> can be used to
'specify configuration information for a ScriptBasic program. Here
'we describe the differences and how to use the two functions for
'single-process single-basic and for single-process multiple-basic
'applications.
'
'To execute a ScriptBasic program you usually need configuration information.
'The configuration information for the interpreter is stored in a file.
'The function R<scriba_LoadConfiguration()> reads the file and loads it into memory
'into the T<SbProgram> object. When the object is destroyed the configuration
'information is automatically purged from memory.
'
'Some implementations like the Eszter SB Engine variation of ScriptBasic starts
'several interpreter thread within the same process. In this case the configuration
'information is read only once and all the running interpreters share the same
'configuration information.
'
'To do this the embedding program has to create a pseudo T<SbProgram> object that
'does not run any ScriptBasic program, but is used only to load the configuration
'information calling the function R<scriba_LoadConfiguration()>. Other T<SbProgram> objects
'that do intepret ScriptBasic program should inherit this configuration calling the
'function R<scriba_InheritConfiguration()>. When a T<SbProgram> object is destroyed the
'configuration is not destroyed if that was inherited belonging to a different object.
'It remains in memory and can later be used by other intrepreter instances.
'
'Inheriting the configuration is fast because it does not require loading the
'configuration information from file. This is essentially sets a pointer in the
'internal interpreter structure to point to the configuration information held
'by the other object and all the parallel running interpreters structures
'point to the same piece of memory holding the common configuration information.
'
'See the configuration handling functions R<scriba_LoadConfiguration()> and R<scriba_InheritConfiguration()>.

'int scriba_LoadConfiguration(pSbProgram pProgram, char *pszForcedConfigurationFileName);
declare function scriba_LoadConfiguration lib "libscriba.dll" alias "scriba_LoadConfiguration" (byval pSbProgram as ulong, byval pszForcedConfigurationFileName as zstring ptr) as long






'GET CONFIG FILENAME

'This function tells whet the configuration file is. There is no need to call this function to read the configuration file.
'This is needed only when the main program want to manipulate the configuration file in some way. For example the command
'line version of ScriptBasic uses this function when the option T<-k> is used to compile a configuration file.
'
'The first argument has to be a valid ScriptBasic program object. The second argument should point to a valid T<char *> pointer that
'will get the pointer value to the configuration file name after the function returns.

'The function returns zero if no error happens, or the error code.

'int scriba_GetConfigFileName(pSbProgram pProgram, char **ppszFileName);
declare function  scriba_GetConfigFileName lib "libscriba.dll" alias "scriba_GetConfigFileName" (byval pSbProgram as ulong, ppszFileName as ulong) as long







'INHERIT CONFIGURATION

'Use this function to get the configuration from another program object.

'The return value is zero on success and error code if error has happened.

'int scriba_InheritConfiguration(pSbProgram pProgram, pSbProgram pFrom);
declare function  scriba_InheritConfiguration lib "libscriba.dll" alias "scriba_InheritConfiguration" (byval pSbProgram as ulong, byval pFrom as ulong) as long






'INIT MODULE INTERFACE

'Initialize the Support Function Table of a process level ScriptBasic program object to be inherited
'by other program objects. If you read it first time, read on until you understand what this
'function really does and rather how to use it!
'
'This is going to be a bit long, but you better read it along with the documentation of the
'function R<scriba_InheritModuleInterface()>.
'
'This function is needed only for programs that are
'=itemize
'=item multi thread running several interpreters simultaneous in a single process
'=item support modules like the sample module T<mt> that support multithread behaviour and
'      need to implement worker thread needing call-back functions.
'=noitemize
'
'You most probably know that modules can access system and ScriptBasic fucntions via a
'call-back table. That is a huge T<struct> containing pointers to the functions that
'ScriptBasic implements. This is the T<ST> (aka support table).
'
'This helps module writers to write system independent
'code as well as to access ScriptBasic functions easily. On the other hand modules are
'also free to alter this table and because many functions, tough not all are called via this
'table by ScriptBasic itself a module may alter the core behavior of ScriptBasic.
'
'For this reason each interpreter has its own copy of T<ST>.
'This means that if an interpreter alters the table it has no effect on another interpreter
'running in the same process in anther thread.
'
'This is fine so far. How about modules that run asynchronous threads? For example the very first
'interpter thread that uses the module T<mt> starts in the initialization a thread that later 
'deletes all sessions that time out. This thread lives a long life.
'
'The thread that starts the worker thread is an interpreter thread and has its own copy of the T<ST>.
'The thread started asynchronous however should not use this T<ST> because the table is purged 
'from memory when the interpreter instance it blelonged to finishes.
'
'To have T<ST> for worker threads there is a need for a program object that is not purged
'from memory so long as long the process is alive. Fortunately there is such an object: the
'configuration program object. Configuration is usually read only once by multi-thread implementations
'and the same configuration information is shared by the serveral threads. The same way the
'several program objects may share a T<ST>.
'
'The difference is that configuration is NOT altered by the interpreter or by any module in any way
'but T<ST> may. Thus each  execution object has two pointers: T<pST> and T<pSTI>. While T<pST> points to
'the support table that belongs to the interpreter instance the secondpointer T<pSTI> points to
'a T<ST> that is global for the whole process and is permanent. This T<ST> is to be used by worker threads
'and should not be altered by the module without really good reason.
'
'Thus: Don't call this function for normal program objects! For usualy program objects module
'interface is automatically initialized when the first module function is called. Call this function
'to initialize a T<ST> for a pseudo program object that is never executed but rather used to inherit this
'T<ST> for worker threads.
'
'int scriba_InitModuleInterface(pSbProgram pProgram);
declare function  scriba_InitModuleInterface lib "libscriba.dll" alias "scriba_InitModuleInterface" (byval pSbProgram as ulong) as long







'INHERIT MODULE INTERFACE

'Inherit the support function table (T<ST>) from another program object.
'
'Note that the program object is going to initialize its own T<ST> the normal
'way. The inherited T<ST> will only be used by worker threads that live a long
'life and may exist when the initiating interpreter thread already exists.
'
'For further information please read the description of the function R<scriba_InitModuleInterface()>.

'int scriba_InheritModuleInterface(pSbProgram pProgram, pSbProgram pFrom);
declare function  scriba_InheritModuleInterface lib "libscriba.dll" alias "scriba_InheritModuleInterface" (byval pSbProgram as ulong, byval pFrom as ulong) as long







'INHERIT EXECUTE OBJECT
'
'int scriba_InheritExecuteObject(pSbProgram pProgram, pSbProgram pFrom);
declare function  scriba_InheritExecuteObject lib "libscriba.dll" alias "scriba_InheritExecuteObject" (byval pSbProgram as ulong, byval pFrom as ulong) as long






'SET PROCESS OBJECT

'Use this program in multi-thread environment to tell the actual interpreter
'which object is the process level pseudo object that 
'
'=itemize
'=item holds the shared (among interpreter thread objects) configuration 
'information (see R<scriba_InheritConfiguration()>)
'=item holds the process level module interface (see R<scriba_InheritModuleInterface()>)
'=item holds the list of loaded modules that are not unloaded by the thread loaded the module
'=noitemize
'
'If the embeddingprogram calls this function there is no need to call R<scriba_InheritConfiguration()>
'and R<scriba_InheritModuleInterface()>. This function call does all those tasks and also other things.

'int scriba_SetProcessSbObject(pSbProgram pProgram, pSbProgram pProcessObject);
declare function  scriba_SetProcessSbObject lib "libscriba.dll" alias "scriba_SetProcessSbObject" (byval pSbProgram as ulong, byval pProcessObject as ulong ) as long





'SHUTDOWN MT MODULES

'A multi threaded application should call this function for the process SB object
'when the process finishes. Calling this function will call each of the shutdown
'functions of those external modules that decided to keep in memory and export
'the shutdown function named T<shutmodu>. This allows these modules to gracefully
'shut down their operation. As an example cached data can be written to disk, or
'database connections can be closed.

'int scriba_ShutdownMtModules(pSbProgram pProgram);
declare function  scriba_ShutdownMtModules lib "libscriba.dll" alias "scriba_ShutdownMtModules" (byval pSbProgram as ulong) as long





'SET CGI FLAG
'
'You can call this function to tell the reporting subsystem that
'this code runs in a CGI environment and therefore it should format
'error messages according to the CGI standard sending to the 
'standard output including HTTP headers and HTML code pieces.

'void scriba_SetCgiFlag(pSbProgram pProgram);
declare sub scriba_SetCgiFlag lib "libscriba.dll" alias "scriba_SetCgiFlag" (byval pSbProgram as ulong)







'SET REPORT FUNCTION

'This function should be used to set the report function for a program. The report function
'is used to send info, warning, error, fatal and internal error messages to the user.
'
'In case you want to implement a specific report function see the sample implementation in the
'file T<report.c>. The documentation of the function T<report_report> describes not only the details
'of the sample implementation but also the implementation requests for other reporting functions.

'void scriba_SetReportFunction(pSbProgram pProgram,  void *fpReportFunction);
declare sub scriba_SetReportFunction lib "libscriba.dll" alias "scriba_SetReportFunction" (byval pSbProgram as ulong,  byval fpReportFunction as ulong)





'SET REPORT POINTER

'This pointer will be passed to the reporting function. The default
'reporting uses this pointer as a T<FILE *> pointer. The default value
'for this pointer is T<stderr>.
'
'Other implementations of the reporting function may use this pointer
'according their needs. For example the WIN32 IIS ISAPI implementation
'uses this pointer to point to the extension controll block structure.

'void scriba_SetReportPointer(pSbProgram pProgram, void *pReportPointer);
declare sub scriba_SetReportPointer lib "libscriba.dll" alias "scriba_SetReportPointer" (byval pSbProgram as ulong, pReportPointer as ulong)







'SET STDIN

'You can call this function to define a special standard input function. This
'pointer should point to a function that accepts a T<void *> pointer
'as argument. Whenever the ScriptBasic program tries to read from the
'standard input it calls this function pasing the embedder pointer as
'argument.
'
'If the T<stdin> function is not defined or the parameter is T<NULL>
'the interpreter will read the normal T<stdin> stream.

'void scriba_SetStdin(pSbProgram pProgram, void *fpStdinFunction);
declare sub scriba_SetStdin lib "libscriba.dll" alias "scriba_SetStdin" (byval pSbProgram as ulong, byval fpStdinFunction as ulong)







'SET STDOUT

'You can call this function to define a special standard output function. This
'pointer should point to a function that accepts a T<(char, void *)> arguments.
'Whenever the ScriptBasic program tries to send a character to the standard output
'it calls this function. The first parameter is the character to write, the second
'is the embedder pointer.
'
'If the standard output function is not defined or the parameter is T<NULL>
'the interpreter will write the normal T<stdout> stream.

'void scriba_SetStdout(pSbProgram pProgram, void *fpStdoutFunction);
declare sub scriba_SetStdout lib "libscriba.dll" alias "scriba_SetStdout" (byval pSbProgram as ulong, byval fpStdoutFunction as ulong)






'SET EMBED POINTER

'This function should be used to set the embed pointer.
'
'The embed pointer is a pointer that is not used by ScriptBasic itself. This
'pointer is remembered by ScriptBasic and is passed to call-back functions.
'Like the standard input, output and environment functions that the embedding
'application may provide this pointer is also available to external modules implemented
'in C or other compiled language in DLL or SO files.
'
'The embedder pointer should usually point to the T<struct> of the thread local data.
'For example the Windows NT IIS variation of ScriptBasic sets this variable to point to
'the extension control block.
'
'If this pointer is not set ScriptBasic will pass T<NULL> pointer to the extensions and
'to the call-back function.

'void scriba_SetEmbedPointer(pSbProgram pProgram, void *pEmbedder);
declare sub scriba_SetEmbedPointer lib "libscriba.dll" alias "scriba_SetEmbedPointer" (byval pSbProgram as ulong, byval pEmbedder as ulong)





'SET ENVIRONMENT

'You can call this function to define a special environment query function. This
'pointer should point to a function that accepts a T<(void *, char *, long )> arguments.
'
'Whenever the ScriptBasic program tries to get the value of an enviroment variable
'it calls this function. The first argument is the embedder pointer.
'
'The second argument is the name of the environment variable to retrieve or T<NULL>.
'
'The third argument is either zero or is the serial number of the environment variable.
'
'ScriptBasic never calls this function with both specifying the environment variable name
'and the serial number.
'
'The return value of the function should either be T<NULL> or should point to a string that
'holds the zero character terminated value of the environment variable. This string is not
'changed by ScriptBasic.
'
'If the special environment function is not defined or is T<NULL> ScriptBasic uses the
'usual environment of the process calling the system functionT<getenv>.
'
'For a good example of a self-written environment function see the source of the Eszter SB Engine
'that alters the environment function so that the ScriptBasic programs feel as if they were executed in a
'real CGI environment.

'void scriba_SetEnvironment(pSbProgram pProgram, void *fpEnvirFunction);
declare sub scriba_SetEnvironment lib "libscriba.dll" alias "scriba_SetEnvironment" (byval pSbProgram as ulong, byval pEnvirFunction as ulong)






'LOAD BINARY PROGRAM WITH OFFSET

'Use this function to load ScriptBasic program from a file that is already compiled into
'internal form, and the content of the program is starting on T<lOffset>
'
'The return value is the number of errors (hopefully zero) during program load.
'
'Before calling this function the function R<scriba_SetFileName()> should have been called specifying the
'file name.

'int scriba_LoadBinaryProgramWithOffset(pSbProgram pProgram, byval lOffset as long, long lEOFfset);
declare function scriba_LoadBinaryProgramWithOffset lib "libscriba.dll" alias "scriba_LoadBinaryProgramWithOffset" (byval pSbProgram as ulong, byval lOffset as long , byval lEOFfset as long) as long








'LOAD BINARY PROGRAM

'Use this function to load ScriptBasic program from a file that is already compiled into
'internal form.
'
'The return value is the number of errors (hopefully zero) during program load.

'int scriba_LoadBinaryProgram(pSbProgram pProgram);
declare function scriba_LoadBinaryProgram lib "libscriba.dll" alias "scriba_LoadBinaryProgram" (byval pSbProgram as ulong) as long






'INHERIT BINARY PROGRAM

'The function inherits the binary code from the program object T<pFrom>.
'In server type applications the compiled binary code of a BASIC program may
'be kept in memory. To do this a pseudo program object should be created that
'loads the binary code and is not destroyed.
'
'The program object used to execute the code should inherit the binary code from
'this pseudo object calling this function. This is similar to the configuration
'inheritance.

'int scriba_InheritBinaryProgram(pSbProgram pProgram, pSbProgram pFrom);
declare function scriba_InheritBinaryProgram lib "libscriba.dll" alias "scriba_InheritBinaryProgram" (byval pSbProgram as ulong, byval pFrom as ulong) as long







'LOAD INTERNAL PREPROCESSOR

'This function can be used by embedding applications to load an
'internal preprocessor into the interpereter. Note that preprocessors
'are usually loaded by the reader module when a T<preprocess> statement
'is found. However some preprocessors in some variation of the interpreter
'may be loaded due to configuration or command line option and not
'because the source requests it.
'
'The preprocessors that are requested to be loaded because the source
'contains a T<preprocess> line usually implement special language
'fetures. The preprocessors that are loaded independent of the source
'because command line option or some other information tells the variation
'to call this function are usually debuggers, profilers.
'
'(To be honest, by the time I write it there is no any internal preprocessors
'developed except the test one, but the statement above will become true.)
'
'The first argument is the program object. If the program object does not
'have a preprocessor object the time it is called the preprocessor object is
'created and initiated.
'
'The second argument is the array of names of the preprocessor as it is present
'in the configuration file. This is not the name of the DLL/SO file, but
'rather the symbolic name, which is associated with the file. The final element
'of the array has to be T<NULL>.
'
'The return value is zero or the error code.

'int scriba_LoadInternalPreprocessor(pSbProgram pProgram, char *ppszPreprocessorName[]);
declare function scriba_LoadInternalPreprocessor lib "libscriba.dll" alias "scriba_LoadInternalPreprocessor" (byval pSbProgram as ulong, ppszPreprocessorName as ulong) as long







'READ SOURCE

'Loads the source code of a ScriptBasic program from a text file.
'
'The return code is the number of errors happened during read.
'
'B<Do not get confused!> This function only reads the source. Does not compile it.
'You will usually need R<scriba_LoadSourceProgram()> that does reading, analyzing, building
'and all memory releases leaving finally a ready-to-run code in memory.
'
'Before calling this function the function R<scriba_SetFileName()> should have been called specifying the
'file name.
'
'int scriba_ReadSource(pSbProgram pProgram);
declare function scriba_ReadSource lib "libscriba.dll" alias "scriba_ReadSource" (byval pSbProgram as ulong) as long







'DO LEXICAL ANALYSIS

'This function performs lexical analysis after the source file has beed read.
'
'This function is rarely needeed by applicationdevelopers. See R<scriba_LoadSourceProgram()>
'instead.
'
'See also R<scriba_ReadSource()>, R<scriba_DoLexicalAnalysis()>,
'R<scriba_DoSyntaxAnalysis()>, R<scriba_BuildCode()>.
'
'int scriba_DoLexicalAnalysis(pSbProgram pProgram);
declare function scriba_DoLexicalAnalysis lib "libscriba.dll" alias "scriba_DoLexicalAnalysis" (byval pSbProgram as ulong) as long








'DO SYNTAX ANALYSIS

'This function performs syntax analysis after the lexical analysis has been finished.
'
'This function is rarely needeed by applicationdevelopers. See R<scriba_LoadSourceProgram()>
'instead.
'
'See also R<scriba_ReadSource()>, R<scriba_DoLexicalAnalysis()>,
'R<scriba_DoSyntaxAnalysis()>, R<scriba_BuildCode()>.
'
'int scriba_DoSyntaxAnalysis(pSbProgram pProgram);
declare function scriba_DoSyntaxAnalysis lib "libscriba.dll" alias "scriba_DoSyntaxAnalysis" (byval pSbProgram as ulong) as long







'BUILD CODE

'This function builds the finall ready-to-run code after the syntax
'analisys has been finished.
'
'This function is rarely needeed by applicationdevelopers. See R<scriba_LoadSourceProgram()>
'instead.
'
'See also R<scriba_ReadSource()>, R<scriba_DoLexicalAnalysis()>,
'R<scriba_DoSyntaxAnalysis()>, R<scriba_BuildCode()>.
'
'int scriba_BuildCode(pSbProgram pProgram);
declare function scriba_BuildCode lib "libscriba.dll" alias "scriba_BuildCode" (byval pSbProgram as ulong) as long








'IS FILE BINARY FORMAT

'This function decides if a file is a correct binary format ScriptBasic
'code file and returns true if it is binary. If the file is a ScriptBasic
'source file or an older version binary of ScriptBasic or any other file
'it returns zero.
'
'This function just calls the function T<build_IsFileBinaryFormat>

'int scriba_IsFileBinaryFormat(pSbProgram pProgram);
declare function scriba_IsFileBinaryFormat lib "libscriba.dll" alias "scriba_IsFileBinaryFormat" (byval pSbProgram as ulong) as long







'GET CACHE FILENAME

'Calculate the name of the cache file for the given source file name and
'store the calculated file name in the program object.
'
'The program returns zero or the error code. It returns T<SCRIBA_ERROR_FAIL> if there
'is no cache directory configured.
'
'The code uses a local buffer of length 256 bytes. The full cached file name should
'fit into this otherwise the program will return T<SCRIBA_ERROR_BUFFER_SHORT>.
'
'The code does not check if there exists an appropriate cache directory or file. It
'just calculates the file name.
'
'int scriba_GetCacheFileName(pSbProgram pProgram);
declare function scriba_GetCacheFileName lib "libscriba.dll" alias "scriba_GetCacheFileName" (byval pSbProgram as ulong) as long









'USE CACHE FILE

'Call this function to test that the cache file is usable. This function
'calls the function R<scriba_GetCacheFileName()> to calculate the cache file name.
'
'If 
'=itemize
'=item the cache file exists
'=item is newer than the source file set by R<scriba_SetFileName()>
'=item is a correct ScriptBasic binary file
'=noitemize
'then this function alters the source file name property (T<pszFileName>)
'of the program object so that the call to R<scriba_LoadBinaryProgram()> will try to
'load the cache file.

'The function returns zero or the error code. The function returns T<SCRIBA_ERROR_FAIL>
'in case the cache file is old, or not valid. Therefore returning a positive value
'does not neccessarily mean a hard error.
'int scriba_UseCacheFile(pSbProgram pProgram);
declare function scriba_UseCacheFile lib "libscriba.dll" alias "scriba_UseCacheFile" (byval pSbProgram as ulong) as long








'SAVE CACHE FILE

'Call this function to generate a cache file after
'a successful program compilation.
'
'The function returns zero (T<SCRIBA_ERROR_SUCCESS>) if there was no error.
'This does not mean that the cache file was saved. If there is no cache
'directory configured doing nothing is success.
'
'Returning any positive error code means that ScriptBasic tried to write a
'cache file but it could not.
'
'int scriba_SaveCacheFile(pSbProgram pProgram);
declare function scriba_SaveCacheFile lib "libscriba.dll" alias "scriba_SaveCacheFile" (byval pSbProgram as ulong) as long







'RUN EXTERNAL PREPROCESSOR

'This function should be called to execute external preprocessors.
'
'This function does almost nothing else but calls the function
'T<epreproc()>.
'
'
'The argument T<ppszArgPreprocessor> should point to a string array. This string array
'should contain the configured names of the preprocessors that are applied one after the
'other in the order they are listed in the array.
'
'Note that this array should contain the symbolic names of the preprocessors. The actual
'preprocessor executable programs, or command lines are defined in the configuration
'file.
'
'After calling this function the source file name property of the program object (T<pszFileName>)
'is also modified so that it points to the result of the preprocessor. This means that after the
'successful return of this function the application may immediately call R<scriba_LoadSourceProgram()>.
'
'If there is any error during the preprocessor execution the function returns some error code
'(returned by T<epreproc>) otherwise the return value is zero.
'
'int scriba_RunExternalPreprocessor(pSbProgram pProgram, char **ppszArgPreprocessor);
declare function scriba_RunExternalPreprocessor lib "libscriba.dll" alias "scriba_RunExternalPreprocessor" (byval pSbProgram as ulong, ppszArgPreprocessor as ulong) as long









'SAVE CODE

'Call this function to save the compiled byte code of the program
'into a specific file. This function is called by the function R<scriba_SaveCacheFile()>.
'
'The function does nothing else, but calls T<build_SaveCode>.
'
'The return code is zero or the error code returned by T<build_SaveCode>.
'
'int scriba_SaveCode(pSbProgram pProgram, char *pszCodeFileName);
declare function scriba_SaveCode lib "libscriba.dll" alias "scriba_SaveCode" (byval pSbProgram as ulong, byval pszCodeFileName as zstring ptr) as long




'void scriba_SaveCCode(pSbProgram pProgram, char *pszCodeFileName);
declare sub scriba_SaveCCode lib "libscriba.dll" alias "scriba_SaveCCode" (byval pSbProgram as ulong, byval pszCodeFileName as zstring ptr)




'void scriba_SaveECode(pSbProgram pProgram, char *pszInterpreter, char *pszCodeFileName);
declare sub scriba_SaveECode lib "libscriba.dll" alias "scriba_SaveECode" (byval pSbProgram as ulong, byval pszInterpreter as zstring ptr, byval pszCodeFileName as zstring ptr)








'LOAD SOURCE PROGRAM

'Call this function to load a BASIC program from its source format after
'optionally checking that there is no available cache file and after
'executing all required preprocessors. This function calls
'R<scriba_ReadSource()>, R<scriba_DoLexicalAnalysis()>, R<scriba_DoSyntaxAnalysis()>, R<scriba_BuildCode()>,
'and also releases the memory that was needed only for code building
'calling R<scriba_PurgeReaderMemory()>, R<scriba_PurgeLexerMemory()>, R<scriba_PurgeSyntaxerMemory()>.
'
'After the successful completion of this program the BASIC program is in
'the memory in the ready-to-run state.
'
'Before calling this function the function R<scriba_SetFileName()> should have been called specifying the
'file name.
'
'The return value is zero (T<SCRIBA_ERROR_SUCCESS>) or the error code returned by the
'underlying layer that has detected the error.
'
'int scriba_LoadSourceProgram(pSbProgram pProgram);
declare function scriba_LoadSourceProgram lib "libscriba.dll" alias "scriba_LoadSourceProgram" (byval pSbProgram as ulong) as long






'LOAD PROGRAM STRING

'Use this function to convert a string containing a BASIC program
'that is already in memory to ready-to-run binary format. This function
'is same as R<scriba_LoadSourceProgram()> except that this function reads the source
'code from a string instead of a file.
'
'The argument T<pProgram> is the program object. The argument T<pszSourceCode>
'is the BASIC program itself in text format. Because the source code may
'contain ZCHAR just for any chance the caller has to provide the number of
'characters in the buffer via the argument T<cbSourceCode>. In case the
'source program is zero terminated the caller can simply say
'T<strlen(pszSourceCode)> to give this argument.
'
'Before calling this function the function R<scriba_SetFileName()> may be called. Altough
'the source code is read from memory and thus there is no source file the
'BASIC program may use the command T<include> or T<import> that includes
'another source file after reading the code. If the program does so the reader
'functions need to know the actual file name of the source code to find
'the file to be included. To help this process the caller using this function
'may set the file name calling R<scriba_SetFileName()>. However that file is never used
'and need not even exist. It is used only to calculate the path of included files
'that are specified using relative path.
'
'The return value is zero (T<SCRIBA_ERROR_SUCCESS>) or the error code returned by the
'underlying layer that has detected the error.
'
'int scriba_LoadProgramString(pSbProgram pProgram, char *pszSourceCode, unsigned long cbSourceCode);
declare function scriba_LoadProgramString lib "libscriba.dll" alias "scriba_LoadProgramString" (byval pSbProgram as ulong, byval pszSourceCode as zstring ptr, byval cbSourceCode as ulong) as long








'RUN

'Call this function to execute a program. Note that you can call this function
'many times. Repetitive execution of the same program will execute the
'ScriptBasic code again and again with the global variables keeping their values.
'
'If you want to reset the global variables you have to call R<scriba_ResetVariables()>.
'
'There is no way to keep the value of the local variables.
'
'The argument T<pszCommandLineArgument> is the command part that is passed to the
'BASIC program.
'
'The return value is zero in case of success or the error code returned by the underlying
'execution layers.
'
'Note that you can not call BASIC subroutines or functions without initializations that
'T<scriba_Run> performs. You also can not access global variables. Therefore you either have
'to call T<scriba_Run> or its brother R<scriba_NoRun()> that performs the initializations without execution.
'
'You also have to call R<scriba_NoRun()> if you want to execute a program with some global variables
'having preset values that you want to set from the embedding C program. In that case you
'have to call R<scriba_NoRun()> then one or more times R<scriba_SetVariable()> and finally T<Run>.
'
'int scriba_Run(pSbProgram pProgram, char *pszCommandLineArgument);
declare function scriba_Run lib "libscriba.dll" alias "scriba_Run" (byval pSbProgram as ulong, byval pszCommandLineArgument as zstring ptr) as long








'NO RUN

'In case the embedding program want to set global variables and
'execute subroutines without or before starting the main program it has to call this
'function first. It does all the initializations that are done by
'R<scriba_Run()> except that it does not actually execute the program.
'
'After calling this function the main program may access global variables
'and call BASIC functions.
'
'See also R<scriba_Run()>.
'
'int scriba_NoRun(pSbProgram pProgram);
declare function scriba_NoRun lib "libscriba.dll" alias "scriba_NoRun" (byval pSbProgram as ulong) as long






'RESET VARIABLES

'Call this function if you want to execute a program object that was already executed
'but you do not want the global variables to keep their value they had when
'the last execution of the BASIC code finished.
'
'Global variables in ScriptBasic are guaranteed to be T<undef> before they get any other
'value and some programs depend on this.
'
'
'See also R<scriba_SetVariable()>, R<scriba_Run()>, R<scriba_NoRun()>.
'void scriba_ResetVariables(pSbProgram pProgram);
declare sub scriba_ResetVariables lib "libscriba.dll" alias "scriba_ResetVariables" (byval pSbProgram as ulong)






'CALL

'This function can be used to call a function or subroutine. This function does not
'get any arguments and does not provide any return value.
'
'The return value is zero or the error code returned by the interpreter.
'
'B<Note on how to get the Entry Node value:>
'
'The argument T<lEntryNode> should be the node index of the subroutine or function that
'we want to execute. This can be retrieved using the function R<scriba_LookupFunctionByName()> if the
'name of the function or subroutine is know. Another method is that the BASIC program
'stored this value in some global variables. BASIC programs can access this information
'calling the BASIC function T<Address( f() )>.
'
'int scriba_Call(pSbProgram pProgram, unsigned long lEntryNode);
declare function scriba_Call lib "libscriba.dll" alias "scriba_Call" (byval pSbProgram as ulong, byval lEntryNode as ulong) as long







'CALL ARG

'This function can be used to call a function or subroutine with arguments passed by value.
'Neither the return value of the SUB nor the modified argument variables are not accessible 
'via this function. T<CallArg> is a simple interface to call a ScriptBasic subroutine or
'function with argument.
'
'
'Arguments
'
'=itemize
'=item T<pProgram> is the class variable.
'=item T<lEntryNode> is the start node of the SUB. (See R<scriba_Call()> note on how to get the entry node value.)
'=item T<pszFormat> is a format string that defines the rest of the areguments
'=noitemize
'
'The format string is case insensitive. The characters T<u>, T<i>, T<r>, T<b> and T<s> have meaning.
'All other characters are ignored. The format characters define the type of the arguments
'from left to right.
'
'=itemize
'=item T<u> means to pass an T<undef> to the SUB. This format character is exceptional that it does not
'consume any function argument.
'=item T<i> means that the next argument has to be T<long> and it is passed to the BASIC SUB as an integer.
'=item T<r> means that the next argument has to be T<double> and it is passed to the BASIC SUB as a real.
'=item T<s> means that the next argument has to be T<char *> and it is passed to the BASIC SUB as a string.
'=item T<b> means that the next two arguments has to be T<long cbBuffer> and T<unsigned char *Buffer>.
'The T<cbBuffer> defines the length of the T<Buffer>.
'=noitemize
'
'Note that this SUB calling function is a simple interface and has no access to the modified values of the argument
'after the call or the return value.
'
'If you need any of the functionalities that are not implemented in this function call a more sophisticated
'function.
'
'Example:
'=verbatim
'
'  iErrorCode = scriba_CallArg(&MyProgram,lEntry,"i i s d",13,22,"My string.",54.12);
'
'=noverbatim
'
'int scriba_CallArg(pSbProgram pProgram, unsigned long lEntryNode, char *pszFormat, ...);
declare function scriba_CallArg lib "libscriba.dll" alias "scriba_CallArg" (byval pSbProgram as ulong, byval lEntryNode as ulong, byval pszFormat as zstring ptr, byval nl as ulong) as long








'DESTROY SB ARGS

'This function can be used to release the memory used by arguments created by the
'function R<scriba_NewSbArgs()>.
'
'Arguments:
'=itemize
'=item T<pProgram> class variable
'=item T<Args> pointer returned by R<scriba_NewSbArgs()>
'=item T<cArgs> the number of arguments pointed by T<Args>
'=noitemize
'
'void scriba_DestroySbArgs(pSbProgram pProgram, pSbData Args, unsigned long cArgs);
declare sub scriba_DestroySbArgs lib "libscriba.dll" alias "scriba_DestroySbArgs" (byval pSbProgram as ulong, Args as SbData, byval cArgs as ulong)







'NEW SB ARGS

'Whenever you want to handle the variable values that are returned by the scriba subroutine
'you have to call R<scriba_CallArgEx()>. This function needs the arguments passed in an array of T<SbDtata> type.
'
'This function is a usefuly tool to convert C variables to an array of T<SbData>
'
'The arguments passed are 
'
'=itemize
'=item T<pProgram> is the class variable
'=item T<pszFormat> is the format string
'=noitemize
'
'The format string is case insensitive. The characters T<u>, T<i>, T<r>, T<b> and T<s> have meaning.
'All other characters are ignored. The format characters define the type of the arguments
'from left to right.
'
'=itemize
'=item T<u> means to pass an T<undef> to the SUB. This format character is exceptional that it does not
'consume any function argument.
'=item T<i> means that the next argument has to be T<long> and it is passed to the BASIC SUB as an integer.
'=item T<r> means that the next argument has to be T<double> and it is passed to the BASIC SUB as a real.
'=item T<s> means that the next argument has to be T<char *> and it is passed to the BASIC SUB as a string.
'=item T<b> means that the next two arguments has to be T<long cbBuffer> and T<unsigned char *Buffer>.
'The T<cbBuffer> defines the leng of the T<Buffer>.
'=noitemize
'
'Example:
'
'=verbatim
'
'pSbData MyArgs;
'
'
'  MyArgs = scriba_NewSbArgs(pProgram,"i i r s b",13,14,3.14,"string",2,"two character string");
'  if( MyArgs == NULL )error("memory alloc");
'
'  scriba_CallArgEx(pProgram,lEntry,NULL,5,MyArgs);
'
'=noverbatim
'
'This example passes five arguments to the ScriptBasic subroutine. Note that the last one is only
'two character string, the rest of the characters are ignored.
'
'pSbData scriba_NewSbArgs(pSbProgram pProgram, char *pszFormat, ...);
declare function scriba_NewSbArgs lib "libscriba.dll" alias "scriba_NewSbArgs" (byval pSbProgram as ulong, byval pszFormat as zstring ptr) as ulong






'CALL ARG EX

'This is the most sophisticated function of the ones that call a ScriptBasic subroutine.
'This function is capable handling parameters to scriba subroutines, and returning the
'modified argument variables and the return value.
'
'The arguments:
'=itemize
'=item T<pProgram> is the program object pointer.
'=item T<lEntryNode> is the entry node index where the BASIC subroutine or function starts
'      (See R<scriba_Call()> note on how to get the entry node value.)
'=item T<ReturnValue> is the return value of the function or subroutine
'=item T<cArgs> is the number of argments passed to the function
'=item T<Args> argument data array
'=noitemize
'
'int scriba_CallArgEx(pSbProgram pProgram, unsigned long lEntryNode, pSbData ReturnValue, unsigned long cArgs, pSbData Args);
declare function scriba_CallArgEx lib "libscriba.dll" alias "scriba_CallArgEx" (byval pSbProgram as ulong, byval lEntryNode as ulong, byref ReturnValue as SbData, byval cArgs as ulong, byref Args as SbData) as long








'LOOKUP FUNCTION BY NAME

'This function should be used to get the entry point of a function
'knowing the name of the function. The entry point should not be treated as a
'numerical value rather as a handle and to pass it to functions like
'R<scriba_CallArgEx()>.
'
'The return value of the function is the entry node index of the function named or
'zero if the function is not present in the program.
'
'
'long scriba_LookupFunctionByName(pSbProgram pProgram, char *pszFunctionName);
declare function scriba_LookupFunctionByName lib "libscriba.dll" alias "scriba_LookupFunctionByName" (byval pSbProgram as ulong, byval pszFunctionName as zstring ptr) as long








'LOOKUP VARIABLE BY NAME

'This function can be used to get the serial number of a global variable
'knowing the name of the variable.
'
'Note that all variables belong to a name space. Therefore if you want to
'retrieve the global variable T<foo> you have to name it T<main::foo>.
'
'
'The return value is the serial number of the global avriable or zero if
'there is no variable with that name.
'
'Note that the second argument, the name of the global variable, is not
'going under the usual name space manipulation. You have to specify the
'variable name together with the name space. For example the variable T<a> will
'not be found, but the variable T<main::a> will be.
'
'long scriba_LookupVariableByName(pSbProgram pProgram, char *pszVariableName);
declare function scriba_LookupVariableByName lib "libscriba.dll" alias "scriba_LookupVariableByName" (byval pSbProgram as ulong, byval pszVariableName as zstring ptr) as long







'GET VARIABLE TYPE

'Get the type of the value that a variable is currently holding. This
'value can be
'
'=itemize
'=item T<SBT_UNDEF>
'=item T<SBT_DOUBLE>
'=item T<SBT_LONG>
'=item T<SBT_STRING>
'=noitemize
'
'The argument T<lSerial> should be the serial number of 
'the variable as returned by R<scriba_LookupVariableByName()>.
'
'If there is no variable for the specified serian mumber (T<lSerial> is not positive
'or larger than the number of variables) the function returns T<SBT_UNDEF>.
'
'long scriba_GetVariableType(pSbProgram pProgram, long lSerial);
declare function scriba_GetVariableType lib "libscriba.dll" alias "scriba_GetVariableType" (byval pSbProgram as ulong, byval lSerial as long) as long







'GET VARIABLE

'This function retrieves the value of a variable.
'A new T<SbData> object is created and the pointer to it
'is returned in T<pVariable>. This memory space is automatically
'reclaimed when the program object is destroyed or the function
'T<DestroySbData> can be called.
'
'The argument T<lSerial> should be the serial number of the global variable
'as returned by R<scriba_LookupVariableByName()>.
'
'The funtion returns T<SCRIBA_ERROR_SUCCESS> on success,
'
'T<SCRIBA_ERROR_MEMORY_LOW> if the data cannot be created or
'
'T<SCRIBA_ERROR_FAIL> if the parameter T<lSerial> is invalid.
'
'int scriba_GetVariable(pSbProgram pProgram, long lSerial, pSbData *pVariable);
'declare function scriba_GetVariable lib "libscriba.dll" alias "scriba_GetVariable" (byval pSbProgram as ulong, byval lSerial as long, byref pVariable as SbData) as long
declare function scriba_GetVariable lib "libscriba.dll" alias "scriba_GetVariable" (byval pSbProgram as ulong, byval lSerial as long, byref pVariable as ulong) as long








'SET VARIABLE

'This function sets the value of a global BASIC variable. You can call this function after
'executing the program before it is reexecuted or after successfull call to R<scriba_NoRun()>.
'
'The argument T<lSerial> should be the serial number of the global variable
'as returned by R<scriba_LookupVariableByName()>.
'
'The argument T<type> should be one of the followings:
'
'=itemize
'=item T<SBT_UNDEF>
'=item T<SBT_DOUBLE>
'=item T<SBT_LONG>
'=item T<SBT_STRING>
'=item T<SBT_ZCHAR>
'=noitemize
'
'The function uses one of the arguments T<lSetValue>, T<dSetValue> or T<pszSetValue> and
'the other two are ignored based on the value of the argument T<type>.
'
'If the value of the argument T<type> is T<SBT_UNDEF> all initialization arguments are ignored and the
'global variable will get the value T<undef>.
'
'If the value of the argument T<type> is T<SBT_DOUBLE> the argument T<dSetValue> will be used and the global
'variable will be double holding the value.
'
'If the value of the argument T<type> is T<SBT_LONG> the argument T<lSetValue> will be used and the global
'variable will be long holding the value.
'
'If the value of the argument T<type> is T<SBT_STRING> the argument T<pszSetValue> 
'will be used and the global variable will be long holding the value. The length of the string
'should in this case be specified by the variable T<size>.
'
'If the value of the argument T<type> is T<SBT_ZCHAR> the argument T<pszSetValue> 
'will be used and the global variable will be long holding the value. The length of the string
'is automatically calculated and the value passed in the variable T<size> is ignored. In this case the
'string T<pszSetValue> should be zero character terminated.
'
'The funtion returns T<SCRIBA_ERROR_SUCCESS> on success,
'
'T<SCRIBA_ERROR_MEMORY_LOW> if the data cannot be created or
'
'T<SCRIBA_ERROR_FAIL> if the parameter T<lSerial> is invalid. 
'
'int scriba_SetVariable(pSbProgram pProgram, long lSerial, int type, long lSetValue, double dSetValue, char *pszSetValue, unsigned long size);
declare function scriba_SetVariable lib "libscriba.dll" alias "scriba_SetVariable" (byval pSbProgram as ulong, byval lSerial as long, byval type as long, byval lSetValue as long, byval dSetValue as double, byval pszSetValue as zstring ptr, byval size as ulong) as long







'INIT STATIC MODULES

'This function calls the initialization functions of the modules that are statically linked
'into the interpreter. This is essential to call this fucntion from the embedding T<main()> program
'in a variation that has one or more external modules staticallyl linked. If this function is not
'called the module initialization will not be called, because the module is never actually loaded and
'thus the operating system does not call the T<DllMain> or T<_init> function.
'
'The function has to be called before the first interpreter thread starts. In case of a single
'thread variation this means that the function has to be called before the BASIC program starts.
'
'The function does not take any argument and does not return any value.
'
'void scriba_InitStaticModules(void);
declare sub scriba_InitStaticModules lib "libscriba.dll" alias "scriba_InitStaticModules" ()






'FINISH STATIC MODULES

'This function calls the finalization functions of the modules that are statically linked
'to the interpreter. Such a function for a dynamically loaded module is started by the operating
'system. Because the sttaically linked modules are not loaded the T<_fini> function is not called
'by the UNIX loader and similarly the function T<DllMain> is not called by Windows NT. Because some
'modules depend on the execution of this function this function has to be called after the last
'interpreter thread has finished.
'
'void scriba_FinishStaticModules(void);
declare sub scriba_FinishStaticModules lib "libscriba.dll" alias "scriba_FinishStaticModules" ()

